#ifndef __4DrobotServer_globalVars_h__
#define __4DrobotServer_globalVars_h__

//Note: This isn't a proper header file, as it contains implementations (variable = value).
//      It can therefore only be included in one compilation unit.
//      This is OK as long as we stay within Arduino studio and only use .ino files for code,
//      which are concatonated in alphabetical order.

// Sockets for TCP communications
EthernetServer telnet_socket(telnet_port);
EthernetClient telnet_connection[telnet_numConnections];

// ASCII TTY IO Buffers
// buffCount is the number of elements = idx of first free element
// buffCount_prev is buffCount in the start of the previous parsing round.
//  It is used to print a "$" when done; if now == 0 and prev !=0
//  then this cycle cleared the data from the previous round and are ready.
char           telnet_buff[telnet_numConnections][telnet_bufflen];
size_t         telnet_buffCount[telnet_numConnections];
size_t         telnet_buffCount_prev[telnet_numConnections];

char           serial_buff[telnet_bufflen];
size_t         serial_buffCount;
size_t         serial_buffCount_prev;

char           output_buff[output_bufflen];
size_t         output_buffCount;

// Temperature sensor access & buffers

OneWire            temp_oneWire[temp_numSensorPins];
DallasTemperature  temp_sensors[temp_numSensorPins];
float              temp_data[temp_numSensors]; //[degC]
unsigned long      temp_update_prev = 0;       //[ms]

// Sample grabber servo

Servo grabber_servo;
bool  grabber_go   = false;
int   grabber_goto = 0;
int   grabber_pos  = grabber_closed; //Assumed initial position

// Stepper motors

bool     stepper_go              = false;               //Move a stepper on the next loop?
bool     stepper_go_zero         = false;               //Move-to-position   (false) or
                                                        // move-to-switchLOW (true)?
size_t   stepper_go_axis         = 0;                   //Which stepper to move?
long int stepper_goto            = 0;                   //[steps] Target position
                                                        // (used if stepper_go_zero==false)
bool     stepper_interlock       = true;                //Is the stepper interlock enabled (safe)
                                                        //                   or disabled (unsafe)?
long int stepper_pos[]           = {0,0,0};             //Current stepper position
bool     stepper_mode_absolute[] = {false,false,false}; //Do we have a valid zeroing?
                                                        // If true, pos represents the absolute
                                                        // position of that axis

const unsigned int stepper_maxwait_us = 16383;                       // [us] Maximum value allowed by delayMicroseconds
unsigned int       stepper_accel_profile[stepper_accelerate_steps];  // [us] Stepper acceleration profile
size_t             stepper_accelerate_steps_slow;                    // Truncate the accel_profile after this many steps
                                                                     //      when moving slowly
#endif
