void setup_temperatures() {
  //Initialize temperature sensors to something nonsensical
  for (size_t i=0; i<temp_numSensors; i++) {
    temp_data[i] = -500.0f; //(it's float not Farenheit)
  }

  //Initialize buses
  for(size_t i=0; i<temp_numSensorPins; i++) {
    temp_oneWire[i] = OneWire(temp_oneWire_pins[i]);
    temp_sensors[i] = DallasTemperature(&(temp_oneWire[i]));
  }
}

//Program for refreshing the temperatures
void temperatures_update() {
  //Poll temperature sensors no faster than the given interval
  //If too short, some sensors may heat up and give inaccurate results
  unsigned long thisUpdateTime = millis();
  if (not (thisUpdateTime - temp_update_prev >= temp_update_interval)) {
    //Not yet
    return;
  }
  temp_update_prev = thisUpdateTime;

  //Refresh temp_data
  #ifndef DUMMY_TEMP
  size_t k = 0;
  for(size_t i=0; i<temp_numSensorPins; i++) {

    temp_sensors[i].requestTemperatures();
    for (size_t j=0; j<temp_numSensors_perpin[i]; j++) {
      temp_data[k] = temp_sensors[i].getTempCByIndex(j);
      k++;
    }

  }
  #else
  for (size_t i=0; i < temp_numSensors; i++) {
    temp_data[i] = random(-1000L,15000L)/100.0f;
  }
  #endif
}
