void setup_servo() {
  //Sanity check grabber config
  if (not (grabber_open >= grabber_min && grabber_open <= grabber_max)) {
    Serial.print(F("Grabber config error; grabber_open outside of legal range\n"));
    while(true) {
      delay(1);
    }
  }
  if (not (grabber_closed >= grabber_min && grabber_closed <= grabber_max)) {
    Serial.print(F("Grabber config error; grabber_closed outside of legal range\n"));
    while(true) {
      delay(1);
    }
  }

  //Initialize Servo library
  #ifndef DUMMY_SERVO
  grabber_servo.attach(grabber_servo_pin);
  grabber_servo.write(grabber_pos);
  #endif
}

//Program for controlling the servomotor for the grabber
void servo_control() {
  if (not grabber_go) {
    return;
  }

  //Move!
  bufferWrite(output_buff, sizeof(output_buff), output_buffCount, F("< GRABBER MOVING...\n"));
  output_buff_flush();
  
  while (grabber_pos != grabber_goto) {
    if (grabber_pos < grabber_goto) {
      grabber_pos++;
    }
    else {
      grabber_pos--;
    }

    #ifndef DUMMY_SERVO
    grabber_servo.write(grabber_pos);
    #else
    Serial.print("Grabber to: ");
    Serial.print(grabber_pos);
    Serial.print('\n');
    #endif
    delay(grabber_stepWait);
  }
 
  grabber_go   = false;
  stepper_goto = 0;

  bufferWrite(output_buff, sizeof(output_buff), output_buffCount, F("< GRABBER GO FINISHED\n"));
  output_buff_flush();
}
